Gecode::Int::LDSB::SymmetryImp< View > Class Template Referenceabstract

Implementation of a single symmetry. More...

`#include <ldsb.hh>`

## Public Member Functions

virtual ArgArray< Literal > | symmetric (Literal, const ViewArray< View > &) const =0
| Compute symmetric literals.
virtual void | update (Literal)=0
| Left-branch update.
virtual SymmetryImp< View > * | copy (Space &home) const =0
| Copy function.
virtual size_t | dispose (Space &home)=0
| Disposal.
virtual | ~SymmetryImp (void)
| Unused destructor.

## Static Public Member Functions

static void * | operator new (size_t s, Space &home)
| Placement new operator.
static void | operator delete (void *, Space &)
| Return memory to space.
static void | operator delete (void *)
| Needed for exceptions.

## Detailed Description

template<class View>
class Gecode::Int::LDSB::SymmetryImp< View >

Implementation of a single symmetry.

Definition at line 162 of file ldsb.hh.

## Constructor & Destructor Documentation

## ~SymmetryImp()

template<class View>

Gecode::Int::LDSB::SymmetryImp< View >::~SymmetryImp | ( | void |  | ) |

virtual

Unused destructor.

Definition at line 48 of file sym-imp.hpp.

## Member Function Documentation

## symmetric()

template<class View>

virtual ArgArray< Literal > Gecode::Int::LDSB::SymmetryImp< View >::symmetric | ( | Literal | ,
|  | const ViewArray< View > & | ) const

pure virtual

Compute symmetric literals.

Implemented in Gecode::Int::LDSB::ValueSequenceSymmetryImp< View >, Gecode::Int::LDSB::ValueSymmetryImp< View >, Gecode::Int::LDSB::VariableSequenceSymmetryImp< View >, and Gecode::Int::LDSB::VariableSymmetryImp< View >.

## update()

template<class View>

virtual void Gecode::Int::LDSB::SymmetryImp< View >::update | ( | Literal |  | ) |

pure virtual

Left-branch update.

Implemented in Gecode::Int::LDSB::ValueSequenceSymmetryImp< View >, Gecode::Int::LDSB::ValueSymmetryImp< View >, Gecode::Int::LDSB::ValueSymmetryImp< Gecode::ValSelCommitBase< typenameValSel::View, typenameValSel::Val >::View >, Gecode::Int::LDSB::VariableSequenceSymmetryImp< View >, and Gecode::Int::LDSB::VariableSymmetryImp< View >.

## copy()

template<class View>

virtual SymmetryImp< View > * Gecode::Int::LDSB::SymmetryImp< View >::copy | ( | Space & | home | ) | const

pure virtual

Copy function.

Implemented in Gecode::Int::LDSB::ValueSequenceSymmetryImp< View >, Gecode::Int::LDSB::ValueSymmetryImp< View >, Gecode::Int::LDSB::ValueSymmetryImp< Gecode::ValSelCommitBase< typenameValSel::View, typenameValSel::Val >::View >, Gecode::Int::LDSB::VariableSequenceSymmetryImp< View >, and Gecode::Int::LDSB::VariableSymmetryImp< View >.

## dispose()

template<class View>

virtual size_t Gecode::Int::LDSB::SymmetryImp< View >::dispose | ( | Space & | home | ) |

pure virtual

Disposal.

Implemented in Gecode::Int::LDSB::ValueSequenceSymmetryImp< View >, Gecode::Int::LDSB::ValueSymmetryImp< View >, Gecode::Int::LDSB::ValueSymmetryImp< Gecode::ValSelCommitBase< typenameValSel::View, typenameValSel::Val >::View >, Gecode::Int::LDSB::VariableSequenceSymmetryImp< View >, and Gecode::Int::LDSB::VariableSymmetryImp< View >.

## operator new()

template<class View>

void * Gecode::Int::LDSB::SymmetryImp< View >::operator new | ( | size_t | s,
|  | Space & | home )

static

Placement new operator.

Definition at line 52 of file sym-imp.hpp.

## operator delete() [1/2]

template<class View>

void Gecode::Int::LDSB::SymmetryImp< View >::operator delete | ( | void * | ,
|  | Space & | )

static

Return memory to space.

Definition at line 58 of file sym-imp.hpp.

## operator delete() [2/2]

template<class View>

void Gecode::Int::LDSB::SymmetryImp< View >::operator delete | ( | void * |  | ) |

static

Needed for exceptions.

Definition at line 62 of file sym-imp.hpp.

The documentation for this class was generated from the following files:

- gecode/int/ldsb.hh
- gecode/int/ldsb/sym-imp.hpp